import java.io.*;
import java.util.*;

public class Client {
    public static void main(String[] args) {
      
        /*
        int[] setSizes = {10, 100, 1000, 10000, 100000};
        for (int i = 0; i < setSizes.length; i++) {
            long[] times = containsTest(setSizes[i]);
            System.out.println(Arrays.toString(times));           
        }
        */
        //csvData();

        //exponentialExample(2);
    }

    public static int[] randomDataSet(int n) {
        Random rand = new Random();
        int[] dataSet = new int[n];
        for (int i = 0; i < n; i++) {
            dataSet[i] = rand.nextInt();
        }
        return dataSet;
    }

    public static long[] containsTest(int n) {
        long[] times = new long[6];
        times[0] = n;
        long start = System.nanoTime();
        int[] dataSet = randomDataSet(n);
        int valToFind = -1; // guarnteed not in collection
        long finish = System.nanoTime();
        times[1] = finish - start;

        ArrayIntList arrList = new ArrayIntList();
        for (int i = 0; i < n; i++) {
            arrList.add(dataSet[i]);
        }
        start = System.nanoTime();     
        arrList.contains(valToFind);   
        finish = System.nanoTime();
        times[2] = finish - start;

        LinkedIntList linkList = new LinkedIntList();
        for (int i = 0; i < n; i++) {
            linkList.add(dataSet[i]);
        }
        start = System.nanoTime();
        linkList.contains(valToFind);   
        finish = System.nanoTime();
        times[3] = finish - start;

        IntTree binaryTree = new IntTree();
        for (int i = 0; i < n; i++) {
            binaryTree.add(dataSet[i]);
        }
        start = System.nanoTime();
        binaryTree.contains(valToFind);          
        finish = System.nanoTime();
        times[4] = finish - start;

        IntSearchTree bst = new IntSearchTree();
        for (int i = 0; i < n; i++) {
            bst.add(dataSet[i]);
        }
        start = System.nanoTime();
        bst.contains(valToFind);               
        finish = System.nanoTime();
        times[5] = finish - start; 

        return times;                   
    }

    // generate n random numbers and time how long it takes
    // to run contains on that set of data into each of the data structures
    // we've learned about this quarter. Runs trials trials and 
    // throws away the results for the first discard trials and 
    // reports an average for each data structure
    public static double[] containsMultipleTests(int n, int trials, int discard) {
        long[] totalTimes = new long[6];
        for (int i = 0; i < trials; i++) {
            long[] times = containsTest(n);

            // Add to total if not discarding
            if (i >= discard) {
                for (int j = 0; j < times.length; j++) {
                    totalTimes[j] += times[j];
                }
            }
        }

        // Compute average
        double[] averageTimes = new double[6];
        for (int i = 0; i < totalTimes.length; i++) {
            averageTimes[i] = (double) totalTimes[i] / (trials - discard);
        }
        return averageTimes;
    } 

    public static void csvData() {
        try {
            File resultsFile = new File("timeTest.csv");
            PrintWriter results = new PrintWriter(resultsFile);
            results.println("n,Build Dataset,ArrayIntList,LinkedIntList,IntTree,IntSearchTree");

            for (int i = 1; i <= 10000; i+=100) {
                double[] times = containsMultipleTests(i, 15, 5);
                results.print(times[0]);
                for (int j = 1; j < times.length; j++) {
                    results.print(", " + times[j]);
                }
                results.println();  
            }
            results.close();         
        } catch (IOException e) {
            System.out.println("file error");
        }
    }

    public static void exponentialExample(int n) {
        int count = abStrings(n, "");
        System.out.println("Printed " + count + " combinations");
    }

    public static int abStrings(int n, String soFar) {
        if (soFar.length() == n) {
            System.out.println(soFar);
            return 1;
        } else {
            int count = abStrings(n, soFar + "A");
            count += abStrings(n, soFar + "B");
            return count;
        }
    }
}
